/**
 * The MIT License (MIT)
 *
 * Copyright (c) 2017 Jakub Beneš <benes@webscope.io>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t(require("react"),require("prop-types")):"function"==typeof define&&define.amd?define(["react","prop-types"],t):e.ReactTextareaAutocomplete=t(e.React,e.PropTypes)}(this,function(T,e){"use strict";T=T&&T.hasOwnProperty("default")?T.default:T,e=e&&e.hasOwnProperty("default")?e.default:e;var t="undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};var n,S=(function(e){var u,f,p;u=["direction","boxSizing","width","height","overflowX","overflowY","borderTopWidth","borderRightWidth","borderBottomWidth","borderLeftWidth","borderStyle","paddingTop","paddingRight","paddingBottom","paddingLeft","fontStyle","fontVariant","fontWeight","fontStretch","fontSize","fontSizeAdjust","lineHeight","fontFamily","textAlign","textTransform","textIndent","textDecoration","letterSpacing","wordSpacing","tabSize","MozTabSize"],f="undefined"!=typeof window,p=f&&null!=window.mozInnerScreenX,e.exports=function(e,t,n){if(!f)throw new Error("textarea-caret-position#getCaretCoordinates should only be called in a browser");var r=n&&n.debug||!1;if(r){var o=document.querySelector("#input-textarea-caret-position-mirror-div");o&&o.parentNode.removeChild(o)}var i=document.createElement("div");i.id="input-textarea-caret-position-mirror-div",document.body.appendChild(i);var a=i.style,s=window.getComputedStyle?getComputedStyle(e):e.currentStyle;a.whiteSpace="pre-wrap","INPUT"!==e.nodeName&&(a.wordWrap="break-word"),a.position="absolute",r||(a.visibility="hidden"),u.forEach(function(e){a[e]=s[e]}),p?e.scrollHeight>parseInt(s.height)&&(a.overflowY="scroll"):a.overflow="hidden",i.textContent=e.value.substring(0,t),"INPUT"===e.nodeName&&(i.textContent=i.textContent.replace(/\s/g," "));var l=document.createElement("span");l.textContent=e.value.substring(t)||".",i.appendChild(l);var c={top:l.offsetTop+parseInt(s.borderTopWidth),left:l.offsetLeft+parseInt(s.borderLeftWidth)};return r?l.style.backgroundColor="#aaa":document.body.removeChild(i),c}}(n={exports:{}},n.exports),n.exports),r=t.CustomEvent;var p=function(){try{var e=new r("cat",{detail:{foo:"bar"}});return"cat"===e.type&&"bar"===e.detail.foo}catch(e){}return!1}()?r:"undefined"!=typeof document&&"function"==typeof document.createEvent?function(e,t){var n=document.createEvent("CustomEvent");return t?n.initCustomEvent(e,t.bubbles,t.cancelable,t.detail):n.initCustomEvent(e,!1,!1,void 0),n}:function(e,t){var n=document.createEventObject();return n.type=e,n.detail=t?(n.bubbles=Boolean(t.bubbles),n.cancelable=Boolean(t.cancelable),t.detail):(n.bubbles=!1,void(n.cancelable=!1)),n},o="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e};var s={ESC:27,UP:38,DOWN:40,ENTER:13,TAB:9},l=new function e(){var a=this;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.startListen=function(){a.refCount||document.addEventListener("keydown",a.f),a.refCount++},this.stopListen=function(){a.refCount--,a.refCount||document.removeEventListener("keydown",a.f)},this.add=function(e,t){var n=e;return"object"!==(void 0===n?"undefined":o(n))&&(n=[n]),a.listeners[a.index]={keyCode:n,fn:t},a.index+=1,a.index},this.remove=function(e){delete a.listeners[e],a.index-=1},this.removeAll=function(){a.listeners={},a.index=0},this.index=0,this.listeners={},this.refCount=0,this.f=function(e){for(var t=e.keyCode||e.which,n=0;n<a.index;n+=1){var r=a.listeners[n],o=r.keyCode,i=r.fn;o.includes(t)&&i(e)}}},i=function(){function r(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(e,t,n){return t&&r(e.prototype,t),n&&r(e,n),e}}();function c(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}var u=function(e){function a(){var e,t,n;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,a);for(var r=arguments.length,o=Array(r),i=0;i<r;i++)o[i]=arguments[i];return(t=n=c(this,(e=a.__proto__||Object.getPrototypeOf(a)).call.apply(e,[this].concat(o)))).selectItem=function(){var e=n.props,t=e.item;(0,e.onSelectHandler)(t)},c(n,t)}return function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(a,T.Component),i(a,[{key:"shouldComponentUpdate",value:function(e){return this.props.item!==e.item||this.props.selected!==e.selected||this.props.style!==e.style||this.props.className!==e.className}},{key:"render",value:function(){var e=this.props,t=e.component,n=e.style,r=e.onClickHandler,o=e.item,i=e.selected,a=e.className,s=e.innerRef;return T.createElement("li",{className:"rta__item "+(a||""),style:n},T.createElement("div",{className:"rta__entity "+(!0===i?"rta__entity--selected":""),role:"button",tabIndex:0,onClick:r,onTouchStart:r,onFocus:this.selectItem,onMouseEnter:this.selectItem,ref:s},T.createElement(t,{selected:i,entity:o})))}}]),a}(),f=function(){function r(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(e,t,n){return t&&r(e.prototype,t),n&&r(e,n),e}}();function d(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}var E=function(e){function a(){var e,t,i;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,a);for(var n=arguments.length,r=Array(n),o=0;o<n;o++)r[o]=arguments[o];return(t=i=d(this,(e=a.__proto__||Object.getPrototypeOf(a)).call.apply(e,[this].concat(r)))).state={selectedItem:null},i.onPressEnter=function(e){e.preventDefault();var t=i.props.values;i.modifyText(t[i.getPositionInList()])},i.getPositionInList=function(){var e=i.props.values,t=i.state.selectedItem;return t?e.findIndex(function(e){return i.getId(e)===i.getId(t)}):0},i.getId=function(e){var t=i.props.getTextToReplace(e);return t.key?t.key:"string"!=typeof e&&e.key?e.key:t.text},i.listeners=[],i.itemsRef={},i.modifyText=function(e){if(e){var t=i.props;(0,t.onSelect)((0,t.getTextToReplace)(e))}},i.selectItem=function(e){var t=1<arguments.length&&void 0!==arguments[1]&&arguments[1];i.state.selectedItem!==e&&i.setState({selectedItem:e},function(){t&&i.props.dropdownScroll(i.itemsRef[i.getId(e)])})},i.scroll=function(e){e.preventDefault();var t=i.props.values,n=e.keyCode||e.which,r=i.getPositionInList(),o=void 0;switch(n){case s.DOWN:o=r+1;break;case s.UP:o=r-1;break;default:o=r}o=(o%t.length+t.length)%t.length,i.selectItem(t[o],[s.DOWN,s.UP].includes(n))},i.isSelected=function(e){var t=i.state.selectedItem;return!!t&&i.getId(t)===i.getId(e)},d(i,t)}return function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(a,T.Component),f(a,[{key:"componentDidMount",value:function(){this.listeners.push(l.add([s.DOWN,s.UP],this.scroll),l.add([s.ENTER,s.TAB],this.onPressEnter));var e=this.props.values;e&&e[0]&&this.selectItem(e[0])}},{key:"componentDidUpdate",value:function(e){var t=this,n=e.values,r=this.props.values;n.map(function(e){return t.getId(e)}).join("")!==r.map(function(e){return t.getId(e)}).join("")&&r&&r[0]&&this.selectItem(r[0])}},{key:"componentWillUnmount",value:function(){for(var e=void 0;this.listeners.length;)e=this.listeners.pop(),l.remove(e)}},{key:"render",value:function(){var n=this,e=this.props,t=e.values,r=e.component,o=e.style,i=e.itemClassName,a=e.className,s=e.itemStyle;return T.createElement("ul",{className:"rta__list "+(a||""),style:o},t.map(function(t){return T.createElement(u,{key:n.getId(t),innerRef:function(e){n.itemsRef[n.getId(t)]=e},selected:n.isSelected(t),item:t,className:i,style:s,onClickHandler:n.onPressEnter,onSelectHandler:n.selectItem,component:r})}))}}]),a}();var a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},g=function(e,t){if(Array.isArray(e))return e;if(Symbol.iterator in Object(e))return function(e,t){var n=[],r=!0,o=!1,i=void 0;try{for(var a,s=e[Symbol.iterator]();!(r=(a=s.next()).done)&&(n.push(a.value),!t||n.length!==t);r=!0);}catch(e){o=!0,i=e}finally{try{!r&&s.return&&s.return()}finally{if(o)throw i}}return n}(e,t);throw new TypeError("Invalid attempt to destructure non-iterable instance")},h=function(){function r(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(e,t,n){return t&&r(e.prototype,t),n&&r(e,n),e}}();var m="next",x=function(e){return console.error("RTA: dataProvider fails: "+e+"\n    \nCheck the documentation or create issue if you think it's bug. https://github.com/webscopeio/react-textarea-autocomplete/issues")},y=function(e){function a(e){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,a);var t=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}(this,(a.__proto__||Object.getPrototypeOf(a)).call(this,e));v.call(t),l.add(s.ESC,function(){return t._closeAutocomplete()});var n=t.props,r=n.loadingComponent,o=n.trigger,i=n.value;if(i&&(t.state.value=i),t._createRegExp(),!r)throw new Error("RTA: loadingComponent is not defined");if(!o)throw new Error("RTA: trigger is not defined");return t}return function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}(a,T.Component),h(a,[{key:"componentDidMount",value:function(){l.startListen()}},{key:"componentDidUpdate",value:function(e){var t=e.trigger,n=this.props.trigger;Object.keys(n).join("")!==Object.keys(t).join("")&&this._createRegExp()}},{key:"componentWillUnmount",value:function(){l.stopListen()}},{key:"render",value:function(){var t=this,e=this.props,n=e.loadingComponent,r=e.style,o=e.className,i=e.listStyle,a=e.itemStyle,s=e.listClassName,l=e.itemClassName,c=e.dropdownClassName,u=e.dropdownStyle,f=e.containerStyle,p=e.containerClassName,d=e.loaderStyle,g=e.loaderClassName,h=this.state,m=h.left,y=h.top,v=h.dataLoading,b=h.currentTrigger,w=h.component,C=h.value,S=this._getSuggestions(),x=this._getTextToReplace();return T.createElement("div",{className:"rta "+(!0===v?"rta--loading":"")+" "+(p||""),style:f},T.createElement("textarea",Object.assign({},this._cleanUpProps(),{ref:function(e){t.props.innerRef&&t.props.innerRef(e),t.textareaRef=e},className:"rta__textarea "+(o||""),onChange:this._changeHandler,onSelect:this._selectHandler,onScroll:this._onScrollHandler,onClick:this._onClickAndBlurHandler,onBlur:this._onClickAndBlurHandler,value:C,style:r})),(v||S)&&b&&T.createElement("div",{ref:function(e){t.dropdownRef=e},style:Object.assign({top:y,left:m},u),className:"rta__autocomplete "+(c||"")},S&&w&&x&&T.createElement(E,{values:S,component:w,style:i,className:s,itemClassName:l,itemStyle:a,getTextToReplace:x,onSelect:this._onSelect,dropdownScroll:this._dropdownScroll}),v&&T.createElement("div",{className:"rta__loader "+(null!==S?"rta__loader--suggestion-data":"rta__loader--empty-suggestion-data")+" "+(g||""),style:d},T.createElement(n,{data:S}))))}}],[{key:"getDerivedStateFromProps",value:function(e){var t=e.value;return null==t?null:{value:t}}}]),a}();y.defaultProps={closeOnClickOutside:!1,movePopupAsYouType:!1,value:null,minChar:1,scrollToItem:!0};var v=function(){var C=this;this.state={top:null,left:null,currentTrigger:null,actualToken:"",data:null,value:"",dataLoading:!1,selectionEnd:0,selectionStart:0,component:null},this.getSelectionPosition=function(){return C.textareaRef?{selectionStart:C.textareaRef.selectionStart,selectionEnd:C.textareaRef.selectionEnd}:null},this.getSelectedText=function(){if(!C.textareaRef)return null;var e=C.textareaRef,t=e.selectionStart,n=e.selectionEnd;return t===n?null:C.state.value.substr(t,n-t)},this.setCaretPosition=function(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:0;C.textareaRef&&(C.textareaRef.focus(),C.textareaRef.setSelectionRange(e,e))},this.getCaretPosition=function(){return C.textareaRef?C.textareaRef.selectionEnd:0},this._onSelect=function(e){var t=C.state,n=t.selectionEnd,r=t.currentTrigger,o=t.value;C.props.trigger;if(r){var i=o.slice(0,n),a=new RegExp(r+"[^\\s]*$"),s=i.search(a),l="next"===e.caretPosition?e.text+" ":e.text,c=function(e,t,n){switch(e){case"start":return n;case"next":case"end":return n+t.length;default:if(!Number.isInteger(e))throw new Error('RTA: caretPosition should be "start", "next", "end" or number.');return e}}(e.caretPosition,l,s),u=i.substring(0,s)+l,f=o.replace(i,u);C.setState({value:f,dataLoading:!1},function(){var e=new p("change",{bubbles:!0});C.textareaRef.value=f,C.textareaRef.dispatchEvent(e),C._changeHandler(e);var t=C.textareaRef.scrollTop;C.setCaretPosition(c),window.chrome&&(C.textareaRef.scrollTop=t)})}},this._getTextToReplace=function(){var e=C.state,n=e.currentTrigger,r=e.actualToken,t=C._getCurrentTriggerSettings();if(!n||!t)return null;var o=t.output;return function(e){if("object"===(void 0===e?"undefined":a(e))&&(!o||"function"!=typeof o))throw new Error('Output functor is not defined! If you are using items as object you have to define "output" function. https://github.com/webscopeio/react-textarea-autocomplete#trigger-type');if(o){var t=o(e,n);if(!t||"number"==typeof t)throw new Error('Output functor should return string or object in shape {text: string, caretPosition: string | number}.\nGot "'+String(t)+'". Check the implementation for trigger "'+n+'" and its token "'+r+'"\n\nSee https://github.com/webscopeio/react-textarea-autocomplete#trigger-type for more informations.\n');if("string"==typeof t)return{text:t,caretPosition:m};if(!t.text)throw new Error('Output "text" is not defined! Object should has shape {text: string, caretPosition: string | number}. Check the implementation for trigger "'+n+'" and its token "'+r+'"\n');if(!t.caretPosition)throw new Error('Output "caretPosition" is not defined! Object should has shape {text: string, caretPosition: string | number}. Check the implementation for trigger "'+n+'" and its token "'+r+'"\n');return t}if("string"!=typeof e)throw new Error("Output item should be string\n");return{text:""+n+e+n,caretPosition:m}}},this._getCurrentTriggerSettings=function(){var e=C.state.currentTrigger;return e?C.props.trigger[e]:null},this._getValuesFromProvider=function(){var e=C.state,t=e.currentTrigger,n=e.actualToken,r=C._getCurrentTriggerSettings();if(t&&r){var o=r.dataProvider,i=r.component;if("function"!=typeof o)throw new Error("Trigger provider has to be a function!");C.setState({dataLoading:!0});var a=o(n);a instanceof Promise||(a=Promise.resolve(a)),a.then(function(e){if(!Array.isArray(e))throw new Error("Trigger provider has to provide an array!");if("function"!=typeof i)throw new Error("Component should be defined!");t===C.state.currentTrigger&&(e.length?C.setState({dataLoading:!1,data:e,component:i}):C._closeAutocomplete())}).catch(function(e){return x(e.message)})}},this._getSuggestions=function(){var e=C.state,t=e.currentTrigger,n=e.data;return!t||!n||n&&!n.length?null:n},this._createRegExp=function(){var e=C.props.trigger;C.tokenRegExp=new RegExp("("+Object.keys(e).sort(function(e,t){return e<t?1:t<e?-1:0}).join("|")+")((?:[^\\s])*$)")},this._closeAutocomplete=function(){C.setState({data:null,dataLoading:!1,currentTrigger:null,top:null,left:null})},this._cleanUpProps=function(){var e=Object.assign({},C.props),t=["loadingComponent","containerStyle","minChar","scrollToItem","ref","innerRef","onChange","onCaretPositionChange","className","value","trigger","listStyle","itemStyle","containerStyle","loaderStyle","className","containerClassName","listClassName","itemClassName","loaderClassName","closeOnClickOutside","dropdownStyle","dropdownClassName","movePopupAsYouType"];for(var n in e)t.includes(n)&&delete e[n];return e},this._changeHandler=function(e){var t=C.props,n=t.trigger,r=t.onChange,o=t.minChar,i=t.onCaretPositionChange,a=t.movePopupAsYouType,s=C.state,l=s.top,c=s.left,u=e.target,f=u.selectionEnd,p=u.selectionStart,d=u.value;(r&&e&&(e.persist&&e.persist(),r(e)),i)&&i(C.getCaretPosition());C.setState({value:d});var g=C.tokenRegExp.exec(d.slice(0,f)),h=g&&g[0],m=g&&g[1]||null;if(h&&!(h.length<=o)||(!C.state.currentTrigger||n[C.state.currentTrigger].allowWhitespace)&&C.state.currentTrigger)if(m&&d[g.index-1]&&n[m].afterWhitespace&&!d[g.index-1].match(/\s/))C._closeAutocomplete();else{if(C.state.currentTrigger&&n[C.state.currentTrigger].allowWhitespace){if(g=new RegExp("\\"+C.state.currentTrigger+".*$").exec(d.slice(0,f)),!(h=g&&g[0]))return void C._closeAutocomplete();m=Object.keys(n).find(function(e){return e===h[0]})||null}var y=h;if(m){if(a||null===l&&null===c||C.state.currentTrigger!==m){var v=S(u,f),b=v.top,w=v.left;C.setState({top:b-C.textareaRef.scrollTop||0,left:w})}C.setState({selectionEnd:f,selectionStart:p,currentTrigger:m,actualToken:y},function(){try{C._getValuesFromProvider()}catch(e){x(e.message)}})}}else C._closeAutocomplete()},this._selectHandler=function(e){var t=C.props,n=t.onCaretPositionChange,r=t.onSelect;n&&n(C.getCaretPosition());r&&(e.persist(),r(e))},this._onClickAndBlurHandler=function(e){var t=C.props,n=t.closeOnClickOutside,r=t.onBlur,o=e.relatedTarget;C.dropdownRef&&o instanceof Node&&C.dropdownRef.contains(o)||(n&&C._closeAutocomplete(),r&&(e.persist(),r(e)))},this._onScrollHandler=function(){C._closeAutocomplete()},this._dropdownScroll=function(e){var t=C.props.scrollToItem;if(t){if(!0===t)return n=C.dropdownRef,r=e,o=parseInt(getComputedStyle(r).getPropertyValue("height"),10),i=parseInt(getComputedStyle(n).getPropertyValue("height"),10)-o,a=r.offsetTop,s=n.scrollTop,void(a<s+i&&s<a||(n.scrollTop=a));var n,r,o,i,a,s;if("function"!=typeof t||2!==t.length)throw new Error("`scrollToItem` has to be boolean (true for default implementation) or function with two parameters: container, item.");t(C.dropdownRef,e)}}};return y.propTypes={loadingComponent:e.func.isRequired,minChar:e.number,onChange:e.func,onSelect:e.func,onBlur:e.func,onCaretPositionChange:e.func,className:e.string,containerStyle:e.object,containerClassName:e.string,closeOnClickOutside:e.bool,style:e.object,listStyle:e.object,itemStyle:e.object,loaderStyle:e.object,dropdownStyle:e.object,listClassName:e.string,itemClassName:e.string,loaderClassName:e.string,dropdownClassName:e.string,value:e.string,trigger:function(e){var t=e.trigger;if(!t)return Error("Invalid prop trigger. Prop missing.");for(var n=Object.entries(t),r=0;r<n.length;r+=1){var o=g(n[r],2),i=o[0],a=o[1];if("string"!=typeof i)return Error("Invalid prop trigger. Keys of the object has to be string.");var s=a,l=s.component,c=s.dataProvider,u=s.output,f=s.afterWhitespace,p=s.allowWhitespace;if(!l||"function"!=typeof l)return Error("Invalid prop trigger: component should be defined.");if(!c||"function"!=typeof c)return Error("Invalid prop trigger: dataProvider should be defined.");if(u&&"function"!=typeof u)return Error("Invalid prop trigger: output should be a function.");if(f&&p)return Error("Invalid prop trigger: afterWhitespace and allowWhitespace can be used together")}return null}},y});
